package es.uca.webservices.gamera.ggen.log;

import java.io.File;
import java.io.PrintStream;
import java.io.StringWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.runtime.resource.loader.ClasspathResourceLoader;
import org.apache.velocity.tools.generic.MathTool;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import es.uca.webservices.gamera.api.AnalysisResults;
import es.uca.webservices.gamera.api.ComparisonResult;
import es.uca.webservices.gamera.api.ComparisonResults;
import es.uca.webservices.gamera.ggen.api.generate.GgenIndividualGenerator;
import es.uca.webservices.gamera.ggen.api.genetic.crossover.GACrossoverOperator;
import es.uca.webservices.gamera.ggen.api.genetic.mutation.GAMutationOperator;
import es.uca.webservices.gamera.ggen.api.term.GATerminationCondition;
import es.uca.webservices.gamera.ggen.individuals.Component;
import es.uca.webservices.gamera.ggen.individuals.GgenHistory.Entry;
import es.uca.webservices.gamera.ggen.individuals.GgenIndividual;
import es.uca.webservices.gamera.ggen.individuals.GgenState;
import es.uca.webservices.gamera.api.GAIndividual;
import es.uca.webservices.gamera.api.conf.InvalidConfigurationException;
import es.uca.webservices.testgen.api.parsers.ParserException;

/**
 * Logger that generates a HTML file with the statistics of all the individuals
 * generated by the algorithm.
 * 
 * @author Álvaro Cortijo-García
 */
public class HTMLDataLogger extends NullLogger {
	
	static final Logger LOGGER = LoggerFactory.getLogger(HTMLDataLogger.class);
	
    private String file;

	private PrintStream ps = null;

	private int numberOfProgramMutants;
	private final List<Map<String, List<Integer>>> comparisonResultsByGeneration = new ArrayList<Map<String, List<Integer>>>();
	private final Map<Integer,List<List<String>>> generatedIndividualsByGeneration = new HashMap<Integer,List<List<String>>>();
	private final List<List<GgenIndividual>> individualsByGeneration = new ArrayList<List<GgenIndividual>>();
	private String[] mutantOpNames;
	private String terminationCondition;
	
    public static class CrossoverEntry{
    	private final List<String> fatherComps = new ArrayList<String>();
    	private final List<String> motherComps = new ArrayList<String>();
    	private final List<String> child1Comps = new ArrayList<String>();
    	private final List<String> child2Comps = new ArrayList<String>();
    	private String operator;
    	private String test1;
    	private String test2;
		private List<Integer> crossPoints;
    	
		public CrossoverEntry( GACrossoverOperator op, GgenIndividual father, GgenIndividual mother, GgenIndividual child1, GgenIndividual child2, int t1, int t2, List<Integer> crossPoints) {
    		setOperator(op.getClass().getSimpleName());
        	final int nComponents = father.getNumberComponents();
        	for(int iCmp = 0; iCmp < nComponents; iCmp++ ){
        		fatherComps.add(father.getComponent(iCmp).getValue().toString());
        		motherComps.add(mother.getComponent(iCmp).getValue().toString());
        		child1Comps.add(child1.getComponent(iCmp).getValue().toString());
        		child2Comps.add(child2.getComponent(iCmp).getValue().toString());
        	}
        	setTest1(String.valueOf(t1));
    		setTest2(String.valueOf(t2));
    		setCrossPoints(crossPoints);
		}

    	public List<String> getFather(){
			return fatherComps;
		}
		public List<String> getMother(){
			return motherComps;
		}
		public List<String> getChild1(){
			return child1Comps;
		}
		public List<String> getChild2(){
			return child2Comps;
		}
		public String getOperator() {
			return operator;
		}
		public void setOperator(String operator) {
			this.operator = operator;
		}
		public String getTest1() {
			return test1;
		}
		public void setTest1(String test1) {
			this.test1 = test1;
		}
		public String getTest2() {
			return test2;
		}
		public void setTest2(String test2) {
			this.test2 = test2;
		}
    	public List<Integer> getCrossPoints() {
			return crossPoints;
		}

		public void setCrossPoints(List<Integer> crossPoints) {
			this.crossPoints = crossPoints;
		}
    }

    public static class MutationEntry{
    	private final List<String> originalComps = new ArrayList<String>();
    	private final List<String> mutatedComps = new ArrayList<String>();
    	private String operator;
    	private String test;
    	final List<Integer> mutatedPositions;
    	
    	public MutationEntry(GAMutationOperator op, List<Integer> mutatedComponents, GgenIndividual original, GgenIndividual mutated, int t) {
    		setOperator(op.getClass().getSimpleName());
        	final int nComponents = original.getNumberComponents();
    		for(int iCmp = 0; iCmp < nComponents; iCmp++ ){
        		originalComps.add(original.getComponent(iCmp).getValue().toString());
        		mutatedComps.add(mutated.getComponent(iCmp).getValue().toString());
        	}
    		mutatedPositions = mutatedComponents;
    		setTest(String.valueOf(t));
    	}

		public String getOperator() {
			return operator;
		}

		public void setOperator(String operator) {
			this.operator = operator;
		}

		public String getTest() {
			return test;
		}

		public void setTest(String test) {
			this.test = test;
		}
		public List<String> getOriginal(){
			return originalComps;
		}
		public List<String> getMutated(){
			return mutatedComps;
		}
		public List<Integer> getMutatedPositions(){
			return mutatedPositions;
		}
    }

	private final Map<Integer,List<CrossoverEntry>> crossoverByGeneration = new HashMap<Integer, List<CrossoverEntry>>();
	private final Map<Integer,List<MutationEntry>> mutationByGeneration = new HashMap<Integer, List<MutationEntry>>();
    
    public String getFile() {
        return file;
    }

    public void setFile(String file) {
        this.file = file;
    }
    
	public int getNumberOfProgramMutants() {
		return numberOfProgramMutants;
	}

	public void setNumberOfProgramMutants(int numberOfProgramMutants) {
		this.numberOfProgramMutants = numberOfProgramMutants;
	}

	public String[] getMutantOpNames() {
		return mutantOpNames;
	}

	public void setMutantOpNames(String[] mutantOpNames) {
		this.mutantOpNames = mutantOpNames;
	}

    @Override
    public void generatedProgramMutants(AnalysisResults analysis, List<GAIndividual> programMutants) {
    	setNumberOfProgramMutants(programMutants.size());
    	setMutantOpNames(analysis.getOperatorNames());
    }
    
    @Override
    public void finishedComparison(GgenState state, List<ComparisonResults> results) {
    	
    	final Map<String, List<Integer>> generationComparisonResults = new HashMap<String, List<Integer>>();
    	
    	for(ComparisonResults rs : results){
    		final List<BigInteger> op = rs.getIndividual().getOperator();
    		final List<BigInteger> loc = rs.getIndividual().getLocation();
    		final List<BigInteger> atr = rs.getIndividual().getAttribute();
    		final int order = rs.getIndividual().getOrder();
    		final StringBuilder sb = new StringBuilder();
    		for (int i = 0; i < order; ++i) {
    			if (i > 0) {
    				sb.append(", ");
    			}
    			final String opName = mutantOpNames[op.get(i).intValue()-1];
    			sb.append(String.format("(%s, %s, %s)", opName, loc.get(i),
    					atr.get(i)));
    		}
    		final String programMutant = sb.toString();

    		final List<Integer> row = new ArrayList<Integer>();
    		for(ComparisonResult r : rs.getRow()){
    			row.add(r.getValue());
    		}
    		generationComparisonResults.put(programMutant, row);
    	}
    	
    	comparisonResultsByGeneration.add(generationComparisonResults);
    }	
    
    @Override
    public void generatedIndividual(GgenState state, GgenIndividualGenerator gen, GgenIndividual ind) {
    	final String generator = gen.getClass().getSimpleName();
    	final int currentGeneration = state.getCurrentGeneration();
    	final List<String> components = new ArrayList<String>();
		components.add(generator);

		if(individualsByGeneration.size() <= currentGeneration){
    		final List<GgenIndividual> individuals = new ArrayList<GgenIndividual>();
    		individuals.add(ind);
    		individualsByGeneration.add(individuals);
    	}
    	else{
    		individualsByGeneration.get(currentGeneration).add(ind);
    	}

		components.add(String.valueOf(individualsByGeneration.get(currentGeneration).size()));
		for(Component cmp : ind.getComponents()){
    		components.add(cmp.getValue().toString());
    	}

    	if(!generatedIndividualsByGeneration.containsKey(currentGeneration)){
    		final List<List<String>> generatedIndividuals = new ArrayList<List<String>>();
    		generatedIndividuals.add(components);
    		generatedIndividualsByGeneration.put(currentGeneration, generatedIndividuals);
    	}else{
    		generatedIndividualsByGeneration.get(currentGeneration).add(components);
    	}
    }

    @Override
    public void appliedCrossover(GgenState state, GACrossoverOperator op, GgenIndividual father, GgenIndividual mother, GgenIndividual leftSon, GgenIndividual rightSon, List<Integer> crossPoints) {
    	 
    	final int currentGeneration = state.getCurrentGeneration();
    	final int individualsAddedByGeneration = individualsByGeneration.size() <= currentGeneration ? 0 : individualsByGeneration.get(currentGeneration).size();
		final int test1 = individualsAddedByGeneration+1;
		final int test2 = individualsAddedByGeneration+2;
    	final CrossoverEntry cross = new CrossoverEntry(op, father, mother, leftSon, rightSon, test1, test2, crossPoints);

    	if(!crossoverByGeneration.containsKey(currentGeneration)){
    		List<CrossoverEntry> crossList = new ArrayList<CrossoverEntry>();
    		crossList.add(cross);
    		crossoverByGeneration.put(currentGeneration, crossList);
    	}else{
    		crossoverByGeneration.get(currentGeneration).add(cross);
    	}

		final int populationSize = state.getConfiguration().getPopulationSize();
		if(test1 > populationSize){
			String discardedTest = cross.getTest1().concat("\nDiscarded");
    		cross.setTest1(discardedTest);
    	}    	
    	if(test2 > populationSize){
			String discardedTest = cross.getTest2().concat("\nDiscarded");
    		cross.setTest2(discardedTest);
    	}    	

    }
    
    @Override
    public void appliedMutation(GgenState state, GAMutationOperator op, List<Integer> mutatedComponents, GgenIndividual original, GgenIndividual mutated, boolean previousCrossover, int child) {
    	final int currentGeneration = state.getCurrentGeneration();
    	final int individualsAddedByGeneration = individualsByGeneration.size() <= currentGeneration ? 0 : individualsByGeneration.get(currentGeneration).size();
		final int test = individualsAddedByGeneration+child;
    	final MutationEntry mut = new MutationEntry(op, mutatedComponents, original, mutated, test);

    	if(!mutationByGeneration.containsKey(currentGeneration)){
    		List<MutationEntry> mutList = new ArrayList<MutationEntry>();
    		mutList.add(mut);
    		mutationByGeneration.put(currentGeneration, mutList);
    	}else{
    		mutationByGeneration.get(currentGeneration).add(mut);
    	}
    	
    	if(previousCrossover){
    		List<CrossoverEntry> cross = crossoverByGeneration.get(currentGeneration);
    		if(child == 1){
    			String previousTest = cross.get(cross.size()-1).getTest1().concat("\nBefore\nMutation");
    			cross.get(cross.size()-1).setTest1(previousTest);
    		}else{
    			String previousTest = cross.get(cross.size()-1).getTest2().concat("\nBefore\nMutation");
    			cross.get(cross.size()-1).setTest2(previousTest);    			
    		}
    	}    	

    	if(test > state.getConfiguration().getPopulationSize()){
			String discardedTest = mut.getTest().concat("\nDiscarded");
    		mut.setTest(discardedTest);
    	}    	
    
    }
    
    @Override
    public void addedIndividual(GgenState state, GgenIndividual individual) {
    	final int currentGeneration = state.getCurrentGeneration();
    	if(individualsByGeneration.size() <= currentGeneration){
    		final List<GgenIndividual> individuals = new ArrayList<GgenIndividual>();
    		individuals.add(individual);
    		individualsByGeneration.add(individuals);
    	}
    	else{
    		individualsByGeneration.get(currentGeneration).add(individual);
    	}
    }
    
    @Override
    public void passedTerminationCondition(GATerminationCondition cond) {
    	terminationCondition = cond.getClass().getSimpleName();
    }
    
	@Override
	public void finished(GgenState state) {
    	if(ps == null) {
			try {
				ps = new PrintStream(new File(file));
			} catch (Exception e) {
				LOGGER.error("File not found", e);
			}
    	}
		
    	VelocityEngine ve = new VelocityEngine();
    	ve.setProperty("resource.loader", "class");
    	ve.setProperty("class.resource.loader.class",ClasspathResourceLoader.class.getName());
    	ve.init();
    	Template t = ve.getTemplate("vm/statistic-ggen.vm");
    	VelocityContext context = new VelocityContext();
    	
		final Map<String, List<Integer>> mutantsByGeneration = new HashMap<String, List<Integer>>();
		final List<Integer> deadMutantsGenList = new ArrayList<Integer>();
		final List<Integer> aliveMutantsGenList = new ArrayList<Integer>();
		final List<Integer> invalidMutantsGenList = new ArrayList<Integer>();
		Iterator<Entry> iGeneration = state.getHistory().getEntries().iterator();
		final Set<GAIndividual> deadMutants = new HashSet<GAIndividual>();

		final Map<String, List<Integer>> mutantsStatistics = new HashMap<String, List<Integer>>();
		final List<Integer> totalDeadMutants = new ArrayList<Integer>();
		final List<Integer> totalAliveMutants = new ArrayList<Integer>();
		final List<Integer> totalInvalidMutants = new ArrayList<Integer>();

		final List<List<Double>> fitnessLists= new ArrayList<List<Double>>();
		
		while(iGeneration.hasNext()){
			final Entry generation = iGeneration.next();
			//Get the number of dead, alive and invalid mutants by generation.
			int deadMutantsByGeneration = 0;
			int aliveMutantsByGeneration = 0;
			for(ComparisonResults row : generation.getComparisonsByProgram()){
				if(row.isDead()){
					deadMutants.add(row.getIndividual());
					deadMutantsByGeneration++;
				} else{
					aliveMutantsByGeneration++;
				}
			}
			final int invalidMutantsByGeneration = getNumberOfProgramMutants() - (deadMutantsByGeneration + aliveMutantsByGeneration);
			deadMutantsGenList.add(deadMutantsByGeneration);
			aliveMutantsGenList.add(aliveMutantsByGeneration);
			invalidMutantsGenList.add(invalidMutantsByGeneration);

			//Get the total number of dead, alive and invalid mutants.
			final int numberOfDeadMutants = deadMutants.size();
			totalDeadMutants.add(numberOfDeadMutants);
			final int numberOfAliveMutants = getNumberOfProgramMutants() - (numberOfDeadMutants + invalidMutantsByGeneration);
			totalAliveMutants.add(numberOfAliveMutants);
			totalInvalidMutants.add(invalidMutantsByGeneration);
			
			//Get the fitness of each individual by generation.
			final List<Double> generationFitness = new ArrayList<Double>();
			for(GgenIndividual ind : generation.getPopulation().getPopulation()){
				generationFitness.add(ind.getFitness());
			}
			fitnessLists.add(generationFitness);
		}
		mutantsStatistics.put("dead", totalDeadMutants);
		mutantsStatistics.put("alive", totalAliveMutants);
		mutantsStatistics.put("invalid", totalInvalidMutants);

		mutantsByGeneration.put("dead", deadMutantsGenList);
		mutantsByGeneration.put("alive", aliveMutantsGenList);
		mutantsByGeneration.put("invalid", invalidMutantsGenList);
		
		context.put("mutantsStatistics", mutantsStatistics);
		context.put("mutantsStatisticsByGeneration", mutantsByGeneration);
		context.put("fitnessByGeneration", fitnessLists);
		
		// Get the comparison results by generation.
		context.put("comparisonResults", comparisonResultsByGeneration);

		// Get the new generated individuals by generation.
		context.put("generatedIndividuals", generatedIndividualsByGeneration);
		
		// Get the number of test cases.
		final int numberOfTestCases = state.getCurrentPopulation().getPopulationSize();
		context.put("numberOfTestCases", numberOfTestCases);

		// Get the number of components by individual.
        try {
    		final int numberOfComponents = state.getConfiguration().getTypes().size();
    		context.put("numberOfComponents", numberOfComponents);
        } catch (ParserException e) {
            LOGGER.error("There was an error while parsing the variable declarations", e);
        }

		// Crossover by generation
		context.put("crossoverByGeneration", crossoverByGeneration);

		// Mutation by generation
		context.put("mutationByGeneration", mutationByGeneration);

		// Individuals by generation
		context.put("individualsByGeneration", individualsByGeneration);

		//Get the termination condition passed.
		context.put("terminationCondition", terminationCondition);

		//Add mathTool to the context in order to use math operations.
		context.put("math", new MathTool());

		StringWriter writer = new StringWriter();
		t.merge(context, writer);
		ps.println(writer.toString());
	}
	
	@Override
	public void validate() throws InvalidConfigurationException{
        if (getFile() == null){
            throw new InvalidConfigurationException("File has not been set.");        	
        }
	}
}
